#ifndef _FB_SERVER_H
#define _FB_SERVER_H
#include <asm-generic/errno-base.h>
#include <asm/uaccess.h>
#include <linux/cdev.h>
#include <linux/errno.h>
#include <linux/fb.h>
#include <linux/fs.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/module.h>
#include <linux/random.h>
#include <linux/unistd.h>
#include <linux/vmalloc.h>
#include <linux/version.h>
#include <linux/delay.h>
#include <linux/export.h>
//#include <linux/crypto.h>
#include <linux/scatterlist.h>
#include <linux/proc_fs.h>
#include <linux/spi/spi.h>
#include <linux/spi/spidev.h>
#include <linux/spi/spi_gpio.h>
#include <linux/unistd.h>
#include <linux/semaphore.h>

/******************************
 * type definition
 ******************************/
//#define DEBUG
/***********************************************************************************
 * ディスプレイ固有情報
 ***********************************************************************************/
#define X_RES 256 //x方向ピクセル数
#define Y_RES 64  //y方向ピクセル数
#define VISUAL FB_VISUAL_MONO01 //FB_VISUAL_TRUECOLOR FB_VISUAL_MONO01 FB_VISUAL_MONO10
//#define DUMMY_DISP
//#define UPDATE_CONTROL


#define DEV_NAME "fb"

#define DEV_NUM 1//32
#define DEV_MINOR_NO 0
#define BUFFALO_DRIVER_VER	"1.00"
#define DRIVER_NAME		"Buffalo OLED Display Driver"
#define AUTHOR			"(C) BUFFALO INC."

#define DEV_MSG "fb_server"

/***********************************************************************************
 * 固定値
 ***********************************************************************************/
#define X_LENGTH X_RES

#if VISUAL == FB_VISUAL_TRUECOLOR
#define MONOBPS 8/*1バイトあたりのビット数*/
#define COLOR 3
#define RAMCOLOR 4/*アルファ値が存在する場合、COLOR数+1*/
#define COLOR_OFFSET 1
#else
#define MONOBPS 1
#define COLOR 1
#define RAMCOLOR 1
#define COLOR_OFFSET 0
#endif

#define BPS MONOBPS*RAMCOLOR
#define PIXEL_COUNT X_LENGTH*Y_RES
#define PIXEL_BITS PIXEL_COUNT*BPS
#define PIXEL_BYTES PIXEL_COUNT*BPS/8

#define PROC_DIR_PATH "buffalo/oled"
#define PROC_BRIGHTNESS_PATH "buffalo/oled/brightness"
#define PROC_POWER_PATH "buffalo/oled/power"
#define MD5_LENGTH     16

#ifdef DUMMY_DISP
static int on_display_invalidate(struct file *filp) {
#ifdef DEBUG
	//printk( KERN_INFO "fb_server : on_display_invalidate\n" );
#endif
	return 0;
}
static int on_display_init() {
#ifdef DEBUG
	printk( KERN_INFO "fb_server : on_display_init\n" );
#endif
	return 0;
}
static int on_display_cleanup() {
#ifdef DEBUG
	printk( KERN_INFO "fb_server : on_display_cleanup\n" );
#endif
	return 0;
}
static bool set_brightness(struct fb_server_dev *dev,int bright){
	return false;
}
static int get_brightness(){
	0;
}
static bool set_power(struct fb_server_dev *dev,bool p){
	return false;
}
static bool is_power(){
	return true;
}
#else
int on_display_invalidate(struct fb_info *filp);
int on_display_init(void);
int on_display_cleanup(void);
bool set_brightness(int bright);
int get_brightness(void);
bool set_power(bool p);
bool is_power(void);
#endif

#endif /* _FB_SERVER_H */
