#ifndef _FB_SERVER_H
#define _FB_SERVER_H

#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/errno.h>
#include <linux/fs.h>
#include <linux/device.h>
#include <linux/cdev.h>
#include <linux/input.h>
#include <linux/mm.h>
#include <asm/io.h>
#include <asm/ioctl.h>
#include <asm-generic/errno-base.h>
#include <linux/random.h>
#include <asm/types.h>
#include <linux/unistd.h>
#include <linux/sched.h>
#include <asm/poll.h>
#include <asm/current.h>
#include <linux/delay.h>
#include <linux/poll.h>
#include <linux/wait.h>
#include <linux/kthread.h>
#include <linux/sched.h>
#include <asm/posix_types.h>
#include <linux/version.h>
#include <linux/major.h>
#include <linux/proc_fs.h>
#include <linux/reboot.h>

#include "audio_nas_keycode.h"

/******************************
 * type definition
 ******************************/
typedef unsigned char byte;

/***********************************************************************************
 *ドライバ部
 ***********************************************************************************/
#define DEV_NAME "han1_input"
#define BUFFALO_DRIVER_VER "1.00"
#define DRIVER_NAME "Buffalo Panel Input Driver"
#define AUTHOR "(C) BUFFALO INC."
//#define DEBUG
#define PROC_DIR_PATH "buffalo/ui"
#define PROC_PROGRESS_PATH PROC_DIR_PATH "/progress"
#define PROC_DETAIL_PATH PROC_DIR_PATH "/detail"
#define PROC_IMPORT_1_PATH PROC_DIR_PATH "/import1"
#define PROC_IMPORT_2_PATH PROC_DIR_PATH "/import2"
#define PROC_EXPANSION_PATH PROC_DIR_PATH "/expansion"
#define PROC_EXPANSION_2_PATH PROC_DIR_PATH "/expansion2"
#define PROC_WATCHDOG_PATH PROC_DIR_PATH "/watchdog"
#define PROC_TEST_PATH PROC_DIR_PATH "/virtualkey"
#define PROC_DMR_STATE_PATH PROC_DIR_PATH "/dmr"
#define PROC_NOTIFY_STATE_PATH PROC_DIR_PATH "/notify"
#define PROC_USBODD_1_PATH PROC_DIR_PATH "/usbodd1"
#define PROC_USBODD_2_PATH PROC_DIR_PATH "/usbodd2"
#define DEV_MSG "input_device_server"



#ifdef DEBUG
#define __init
#define __exit
#endif

//ポーリングするキーの数を変えるときはここを変更
#define key_down_poll_list_count 6

//キーの数を変えるときはここを変更
#define key_down_all_list_count 14
union key_down_uni {
	struct key_down_list {
		bool key_left;
		bool key_right;
		bool key_up;
		bool key_down;
		bool key_poweroff;
		bool key_home;//ポーリングするのはここまで
		bool proc_progress;
		bool proc_import_1;
		bool proc_import_2;
		bool proc_expansion;
		bool proc_dmr;
		bool proc_notify;
		bool proc_usbodd_1;
		bool proc_usbodd_2;
		bool proc_expansion_2;
	} list;
	struct key_down_array {
		bool val[key_down_all_list_count];
	} array;
};


//prototype
int on_key_init(void);
int on_key_cleanup(void);
void read_pin_values(volatile union key_down_uni *);

void write_pin(int pin,bool b);

struct input_device_server_dev {
	struct input_dev *input;
	unsigned long last_keydown;
	unsigned long watchdog_timer;
	volatile union key_down_uni *key_buffer;
	spinlock_t lock;
	struct timer_list gpio_timer;
	bool gpio_timer_active;
};

#endif /* _FB_SERVER_H */
